Description

This seems to be requested often:

http://www.redmine.org/issues/4968

https://www.chiliproject.org/issues/166

Currently people are working around this limitation in various ways (adding attachments by mail, constructing multipart form requests,

...).

I just started learning rails and the redmine internals, but wouldn't it be possible to just pass the attachment as base64 encoded string

inside the  issue, -json / xml?

On the issue controller side, something like this might work (it did work for me while testing things out with curl):

diff --git a/app/models/attachment.rb b/app/models/attachment.rb

index 99e461d..e358785 100644

--- a/app/models/attachment.rb

+++ b/app/models/attachment.rb

@@ -144,6 +144,18 @@ class Attachment < ActiveRecord::Base

     if attachments && attachments.is_a?(Hash)

       attachments.each_value do |attachment|

         file = attachment['file']

+        if file.is_a?(Hash)

+          #Looks like we got a base64 encoded file from the api

+          require "base64" 

+          require "tempfile" 

+          base64encodedData = file["data"]

+          tempfile = Tempfile.new("redmine_rest_api_attachment")

+          tempfile.content_type = file["content_type"]

+          tempfile.original_filename = file["original_filename"]

+          tempfile.write(Base64.decode64(file["data"]))

+          tempfile.rewind

+          file = tempfile

+        end

         next unless file && file.size > 0

         a = Attachment.create(:container => obj, 

                               :file => file,

diff --git a/config/initializers/tempfile_for_attachments.rb b/config/initializers/tempfile_for_at

tachments.rb

new file mode 100644

index 0000000..779140e

--- /dev/null

+++ b/config/initializers/tempfile_for_attachments.rb

@@ -0,0 +1,4 @@

+require 'tempfile'

+class Tempfile

+   attr_accessor :content_type, :original_filename

+end

 Not pretty but kind of works. If someone could help me out a bit, I guess we could implement something much cleaner pretty quickly.

2025-05-02 1/3

http://www.redmine.org/issues/4968
https://www.chiliproject.org/issues/166


Bonus points if the thing works out of the box with active resource ;)

Related issues:

Related to Redmine - Feature #4968: REST API new features Closed 2010-03-02

Associated revisions

Revision 8928 - 2012-02-23 11:01 - Jean-Philippe Lang

Adds support for adding attachments to issues through the REST API (#8171).

History

#1 - 2011-04-17 20:50 - Mischa The Evil

- Category set to REST API

Fixed description and category.

#2 - 2011-04-18 00:20 - Etienne Massip

- Target version set to Candidate for next major release

#3 - 2011-10-12 09:25 - Terence Mill

Can u provide an patch for redmine 1.2.1 and a curl example how you test the attachment upload?

Tx for help!

+1 for this feature

#4 - 2011-12-09 14:30 - Bruno Medeiros

Part of this seems to be already done, as we have this page: http://www.redmine.org/projects/redmine/wiki/Rest_Attachments

Could someone update the summary/%done to match the current state?

#5 - 2011-12-12 12:24 - Emmanuel Bourgerie

Hi !

I am in need of such a feature, I'd be glad to test any patch :)

Is there anything functional yet ?

#6 - 2011-12-14 18:57 - Alex Last

several people have asked me to add "upload attachment" to Redmine Java API. I'll have to track this REST API request. Can't do anything in the

Java API until it's supported by REST.

#7 - 2011-12-16 09:27 - Hannes Meier

I am new to redmine and programming but just tested the rest api by using redminews to generate ticktes. It worked pretty easy but i wanted to go a

step ahead now and attach files to the tickets. Then i found this open ticket here.

In my case a kind of "softimport" would be enough, just to give the creator a path information (data in same network like redmine installation) and

redmine would connect (link to) this picture to a ticket/issue.

That would be so awesome.

But even without this feature redmine is a fantastic project! thank you for this great piece of software!

#8 - 2011-12-16 11:35 - Hannes Meier

I am stupid ... I guess this can be done in the description using html ;D or the defined tags. I ll test it but im sure it ll work. sorry

#9 - 2011-12-16 23:04 - Hannes Meier

Well it works with real urls like http://www.arealwebpage.com/image.jpg but not with local files. This seems to be a security issue, or?

So a possibility to attach files to an issue would still be great.

Or is there a way around and a possibilty to include local files in the issue description?

#10 - 2012-02-22 20:43 - Jean-Philippe Lang

- Subject changed from Extend REST Api to support Attachments to Adding attachments through the REST API

- Assignee set to Jean-Philippe Lang

- Target version changed from Candidate for next major release to 1.4.0
#11 - 2012-02-23 11:50 - Jean-Philippe Lang

- Status changed from New to Closed

- Resolution set to Fixed

Feature added in r8928. See Attaching-files in the REST API documentation.

#12 - 2012-03-17 13:06 - Gert van Dijk

Feature #7725, about uploading files in the 'Files' section of a project seems related to this.
